SimpleTestFunctionalTest::testInternalBrowser

7 simpletest.test SimpleTestFunctionalTest::testInternalBrowser()
8 simpletest.test SimpleTestFunctionalTest::testInternalBrowser()

Test the internal browsers functionality.

File

modules/simpletest/simpletest.test, line 44
Tests for simpletest.module.

Code

function testInternalBrowser() {
  global $conf;
  if (!$this->inCURL()) {
    $this->drupalGet('node');
    $this->assertTrue($this->drupalGetHeader('Date'), t('An HTTP header was received.'));
    $this->assertTitle(t('Welcome to @site-name | @site-name', array('@site-name' => variable_get('site_name', 'Drupal'))), t('Site title matches.'));
    $this->assertNoTitle('Foo', t('Site title does not match.'));
    // Make sure that we are locked out of the installer when prefixing
    // using the user-agent header. This is an important security check.
    global $base_url;

    $this->drupalGet($base_url . '/install.php', array('external' => TRUE));
    $this->assertResponse(403, 'Cannot access install.php with a "simpletest" user-agent header.');

    $user = $this->drupalCreateUser();
    $this->drupalLogin($user);
    $headers = $this->drupalGetHeaders(TRUE);
    $this->assertEqual(count($headers), 2, t('There was one intermediate request.'));
    $this->assertTrue(strpos($headers[0][':status'], '302') !== FALSE, t('Intermediate response code was 302.'));
    $this->assertFalse(empty($headers[0]['location']), t('Intermediate request contained a Location header.'));
    $this->assertEqual($this->getUrl(), $headers[0]['location'], t('HTTP redirect was followed'));
    $this->assertFalse($this->drupalGetHeader('Location'), t('Headers from intermediate request were reset.'));
    $this->assertResponse(200, t('Response code from intermediate request was reset.'));

    // Test the maximum redirection option.
    $this->drupalLogout();
    $edit = array(
      'name' => $user->name, 
      'pass' => $user->pass_raw,
    );
    variable_set('simpletest_maximum_redirects', 1);
    $this->drupalPost('user?destination=user/logout', $edit, t('Log in'));
    $headers = $this->drupalGetHeaders(TRUE);
    $this->assertEqual(count($headers), 2, t('Simpletest stopped following redirects after the first one.'));
  }
}
Login or register to post comments